package containers;

public class ConCharQueue implements CharQueue {
	private int front,back;
	private char[] queue;
	private int count;
	
	public ConCharQueue() {
		this(100);
	}
	
	public ConCharQueue(int capacity) {
		this.queue=new char[capacity];
		front=back=count=0;
	}
	
	public void enqueue(char c) {
		if (count>=queue.length) throw new OverflowException();
		queue[back]=c;
		back=(back+1)%queue.length;
		count++;
	}
	
	public char dequeue() {
		if (count<=0) throw new UnderflowException();
		char c=queue[front];
		front=(front+1)%queue.length;
		count--;
		return c;
	}
	
	public char front() {
		if (count<=0) throw new UnderflowException();
		return queue[front];
	}
	
	public boolean isEmpty() {
		return count()<=0;
	}
	
	public int count() {
		return this.count;
	}
}
