package containers;

public class ConCharStack implements CharStack {
	private char[] stk;
	private int top;
	
	public ConCharStack() {
		this(100); //default capacity of 100
	}
	
	public ConCharStack(int capacity) {
		stk=new char[capacity];
		top=0;
	}
	
	public void push(char value) {
		if (top>=stk.length)
			throw new OverflowException();
		stk[top++]=value;
	}
	
	public char pop() {
		if (isEmpty()) throw new UnderflowException();
		return stk[--top];
	}
	
	public char top() {
		if (isEmpty()) throw new UnderflowException();
		return stk[top-1];
	}
	
	public boolean isEmpty() {
		return top<=0;
	}
	
}
