package containers;

public class ConIntStack implements IntStack {
	private int[] stk;
	private int top;
	
	public ConIntStack() {
		this(100); //default capacity of 100
	}
	
	public ConIntStack(int capacity) {
		stk=new int[capacity];
		top=0;
	}
	
	public void push(int value) {
		if (top>=stk.length)
			throw new OverflowException();
		stk[top++]=value;
	}
	
	public int pop() {
		if (isEmpty()) throw new UnderflowException();
		return stk[--top];
	}
	
	public int top() {
		if (isEmpty()) throw new UnderflowException();
		return stk[top-1];
	}
	
	public boolean isEmpty() {
		return top<=0;
	}
	
}
