package containers;

public class LnkCharQueue implements CharQueue {
	private CharNode head;
	private CharNode tail;
	private int count;
	
	public LnkCharQueue() {
		head=new CharNode('\0',null);
		tail=head;
		count=0;
	}
	
	public void enqueue(char c) {
		tail.next=new CharNode(c,null);
		tail=tail.next;
		count++;
	}
	
	public char dequeue() {
		if (isEmpty()) throw new UnderflowException();
		char c=head.next.item;
		head.next=head.next.next;
		count--;
		if (isEmpty()) tail=head;
		return c;
	}
	
	public char front() {
		if (isEmpty()) throw new UnderflowException();
		return head.next.item;
	}
	public boolean isEmpty() {
		return count()<=0;
	}
	
	public int count() {
		return this.count;
	}
}
